﻿using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Linq;
using System.Text;
using System.Windows.Forms;
using Packing;

namespace pack
{
    public partial class Form1 : Form
    {
    bool compress = false;
    byte dicsize = 16;


    public Form1(string[] parametri)
    {
        InitializeComponent();

        if (parametri.Length == 3)
        {
            if (parametri[0] == "-c")
            {
                pack_src.Text = parametri[1];
                pack_dst.Text = parametri[2];
                folderBrowserDialog1.SelectedPath = parametri[1];
                saveFileDialog1.FileName = parametri[2];
            }

            if (parametri[0] == "-x")
            {
                unpack_src.Text =parametri[1];
                
                int cuti = 0;
                for (int i = 0; i < parametri[2].Length; i++)
                {
                    if ( parametri[2][i].ToString() == "\\" )
                        cuti = i;
                }
                string p2 = "";

                for (int i = 0; i < cuti; i++)
                {
                    p2 += parametri[2][i].ToString(); 
                }

                unpack_dest.Text = p2;
                tabControl1.SelectedIndex = 1;
            }
        }
    }

        private void button3_Click(object sender, EventArgs e)
        {
            folderBrowserDialog1.SelectedPath = "";
            folderBrowserDialog1.ShowDialog();
            pack_src.Text = folderBrowserDialog1.SelectedPath;
        }

        private void button4_Click(object sender, EventArgs e)
        {
            saveFileDialog1.FileName = "";
            saveFileDialog1.ShowDialog();
            pack_dst.Text = saveFileDialog1.FileName;
        }

        private void button1_Click(object sender, EventArgs e)
        {

            if (comboBox1.Text == "Enabled")
                compress = true;
            else
                compress = false;

            if (pack_src.Text != "" && pack_dst.Text != "" && backgroundWorker1.IsBusy == false)
                {

                    dicsize = System.Convert.ToByte( comboBox2.Text );
                    button1.Enabled = false;
                    if (backgroundWorker1.IsBusy == false)
                    backgroundWorker1.RunWorkerAsync();
                    status_label.Text = "Working.."; 
                }
                else
                    MessageBox.Show("Choose source and destination paths", "Error", MessageBoxButtons.OK, MessageBoxIcon.Warning);
            }

        private void Form1_Load(object sender, EventArgs e)
        {

        }

        private void textBox3_TextChanged(object sender, EventArgs e)
        {

        }

        private void button5_Click(object sender, EventArgs e)
        {
            openFileDialog1.FileName = "";
            openFileDialog1.ShowDialog();
            unpack_src.Text = openFileDialog1.FileName;
        }

        private void button6_Click(object sender, EventArgs e)
        {
            folderBrowserDialog2.SelectedPath = "";
            folderBrowserDialog2.SelectedPath = "";
            folderBrowserDialog2.ShowDialog();
            unpack_dest.Text = folderBrowserDialog2.SelectedPath;
        }

        private void button2_Click(object sender, EventArgs e)
        {
            if (unpack_src.Text != "" && unpack_dest.Text != "" && backgroundWorker2.IsBusy == false)
            {
                button2.Enabled = false;
                status_label.Text = "Working.."; 
                pack_file p = new pack_file();
                if (backgroundWorker2.IsBusy == false)
                    backgroundWorker2.RunWorkerAsync();
            }
            else
                MessageBox.Show("Choose source and destination paths", "Error", MessageBoxButtons.OK, MessageBoxIcon.Warning);
        }

        private void backgroundWorker1_DoWork(object sender, DoWorkEventArgs e)
        {
            try
            {
                pack_file p = new pack_file();
                p.comrpess = compress;
                p.zw.SetDictonarySize(System.Convert.ToInt32(dicsize));
                p.size = dicsize;
                p.pack(pack_src.Text, pack_dst.Text);
            }
            catch (Exception ex)
            {
                MessageBox.Show(ex.ToString(), "Error", MessageBoxButtons.OK, MessageBoxIcon.Error);
            }

            }

        private void backgroundWorker1_RunWorkerCompleted(object sender, RunWorkerCompletedEventArgs e)
        {
            MessageBox.Show("All done!", "Info", MessageBoxButtons.OK, MessageBoxIcon.Information);
            status_label.Text = "";
            button1.Enabled = true;
        }

        private void backgroundWorker2_DoWork(object sender, DoWorkEventArgs e)
        {
            try
            {
             pack_file p = new pack_file();
             p.unpack(unpack_src.Text, unpack_dest.Text);
            }
            catch (Exception ex)
            {
             MessageBox.Show(ex.ToString(), "Error", MessageBoxButtons.OK, MessageBoxIcon.Error);
            }
        }

        private void backgroundWorker2_RunWorkerCompleted(object sender, RunWorkerCompletedEventArgs e)
        {
            MessageBox.Show("All done!", "Info", MessageBoxButtons.OK, MessageBoxIcon.Information);
            status_label.Text = "";
            button2.Enabled = true;
        }

        private void openFileDialog1_FileOk(object sender, CancelEventArgs e)
        {

        }
    }
}
