﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.IO;

using ulzwdll;

namespace Packing
{
    class pack_file
    {
        FileStream fs;
        public bool comrpess = false;
        public byte size = 16;
        BinaryWriter bw;
        string remove_path = "";
        string output = "";
        public ulzw zw;

        public pack_file()
        {
            comrpess = false;
            zw = new ulzw();
        }

        //check if a path is a folder
        bool IsFolder(string path)
        {
            return ((File.GetAttributes(path) & FileAttributes.Directory) == FileAttributes.Directory);
        }

        public void pack(String src, String dest)
        {
        this.output = dest;    
        int remove_index = 0;
        for (int i = 0; i < src.Length; i++)
        {
            if (src[i] == '\\')
                remove_index = i;
        }

        for (int i = 0; i < remove_index+1; i++)
          this.remove_path += src[i].ToString();

        this.fs = File.Create(dest);
        this.bw = new BinaryWriter(fs);
        this.bw.Write(this.size);
        //check if src a directory
            
         if (  IsFolder ( src ) )
         {
	     //Type 1 = directory
         this.bw.Write(System.Convert.ToByte(1));


         string the_dir = src.Replace(this.remove_path, "");
         the_dir = the_dir.Replace("\\", "/");

	    //Write Filename len
         this.bw.Write(System.Convert.ToByte(the_dir.Length / 256) );
         this.bw.Write(System.Convert.ToByte(the_dir.Length % 256));

         ASCIIEncoding asen = new ASCIIEncoding();
         byte[] ba = asen.GetBytes(the_dir);
         this.bw.Write(ba);
         this.bw.Flush();

         pack_dir(src);
         }

        this.bw.Flush();
        this.bw.Close();
        this.fs.Close();
        }

        void pack_dir(string src)
        {

            //Get and write folders
            string[] fileFolders = Directory.GetDirectories(src);
            foreach (string fn in fileFolders)
            {
                //Type 1 = directory
                this.bw.Write(System.Convert.ToByte(1));
                
                string the_dir = fn;
                the_dir = the_dir.Replace(this.remove_path, "");
                the_dir = the_dir.Replace("\\", "/");

                //Write Filename len
                this.bw.Write(System.Convert.ToByte(the_dir.Length / 256));
                this.bw.Write(System.Convert.ToByte(the_dir.Length % 256));

                ASCIIEncoding asen = new ASCIIEncoding();
                byte[] ba = asen.GetBytes(the_dir);
                this.bw.Write(ba);
                this.bw.Flush();

                pack_dir(fn);
             }

            //Get and write files
            string[] fileNames = Directory.GetFiles(src);
            foreach (string fn in fileNames)
            {
                FileStream sizeStream;
                sizeStream = new FileStream(fn, FileMode.Open); 
                long the_len = sizeStream.Length;
                sizeStream.Close();
                if (comrpess == false || the_len < 10 )
                {

                    //Type 0 = file flag
                    this.bw.Write(System.Convert.ToByte(0));

                    string the_file = fn;
                    the_file = the_file.Replace(this.remove_path, "");
                    the_file = the_file.Replace("\\", "/");

                    //Write Filename len
                    this.bw.Write(System.Convert.ToByte(the_file.Length / 256));
                    this.bw.Write(System.Convert.ToByte(the_file.Length % 256));

                    ASCIIEncoding asen = new ASCIIEncoding();
                    byte[] ba = asen.GetBytes(the_file);
                    this.bw.Write(ba);

                    FileStream readStream;
                    readStream = new FileStream(fn, FileMode.Open);
                    long length = readStream.Length;

                    this.bw.Write(System.Convert.ToByte(length / (4294967296)));
                    this.bw.Write(System.Convert.ToByte((length % (4294967296)) / (256 * 256 * 256)));
                    this.bw.Write(System.Convert.ToByte((length % (256 * 256 * 256)) / (256 * 256)));
                    this.bw.Write(System.Convert.ToByte((length % (256 * 256)) / 256));
                    this.bw.Write(System.Convert.ToByte(length % 256));

                    BinaryReader rb = new BinaryReader(readStream);
                    byte[] buffer = new byte[10000];

                    int letti = 0;

                    //write the file in the package
                    while ((letti = rb.Read(buffer, 0, 10000)) > 0)
                        this.bw.Write(buffer, 0, letti);

                    readStream.Close();
                    rb.Close();
                    this.bw.Flush();
                }
                else
                {

                    //Type 2 = compressed file flag
                    this.bw.Write(System.Convert.ToByte(2));

                    string the_file = fn;
                    the_file = the_file.Replace(this.remove_path, "");
                    the_file = the_file.Replace("\\", "/");

                    //Write Filename len
                    this.bw.Write(System.Convert.ToByte(the_file.Length / 256));
                    this.bw.Write(System.Convert.ToByte(the_file.Length % 256));

                    ASCIIEncoding asen = new ASCIIEncoding();
                    byte[] ba = asen.GetBytes(the_file);
                    this.bw.Write(ba);

                    FileStream readStream;
                    readStream = new FileStream(fn, FileMode.Open);
                    long length = readStream.Length;
                    
                    long pos = this.bw.BaseStream.Position;

                    this.bw.Write(System.Convert.ToByte(length / (4294967296)));
                    this.bw.Write(System.Convert.ToByte((length % (4294967296)) / (256 * 256 * 256)));
                    this.bw.Write(System.Convert.ToByte((length % (256 * 256 * 256)) / (256 * 256)));
                    this.bw.Write(System.Convert.ToByte((length % (256 * 256)) / 256));
                    this.bw.Write(System.Convert.ToByte(length % 256));

                    this.bw.Close();
                    BinaryReader rb = new BinaryReader(readStream);
                    byte[] buffer = new byte[10000];

                    int letti = 0;
                    int flag = 0;

                    System.Text.ASCIIEncoding encoding = new System.Text.ASCIIEncoding();
                    byte[] output_bytes = Encoding.ASCII.GetBytes(output);
                    long comrpessed_size = 0;
                    //write the file in the package
                    while ((letti = rb.Read(buffer, 0, 10000)) > 0)
                    {
                    int received = zw.Compress_buffer_to_file(buffer, letti, output_bytes, flag, 1);
                    comrpessed_size += received;
                    flag = 1;
                    }
                    flag = 3;
                    int recvlast = zw.Compress_buffer_to_file(buffer, 0, output_bytes, flag, 1);
                    comrpessed_size += recvlast;

                    this.bw = new BinaryWriter(File.OpenWrite(this.output));

                    this.bw.BaseStream.Position = pos;

                    this.bw.Write(System.Convert.ToByte(comrpessed_size / (4294967296)));
                    this.bw.Write(System.Convert.ToByte((comrpessed_size % (4294967296)) / (256 * 256 * 256)));
                    this.bw.Write(System.Convert.ToByte((comrpessed_size % (256 * 256 * 256)) / (256 * 256)));
                    this.bw.Write(System.Convert.ToByte((comrpessed_size % (256 * 256)) / 256));
                    this.bw.Write(System.Convert.ToByte(comrpessed_size % 256));
                    this.bw.BaseStream.Position += comrpessed_size;
                    readStream.Close();
                    rb.Close();



                }
            }

        }

        public void unpack(string src, string dest)
        {
            FileStream readStream;
            readStream = new FileStream(src, FileMode.Open);
            long length = readStream.Length;
            BinaryReader rb = new BinaryReader(readStream);
            
            //Process the pack file
            byte[] buffer = new byte[10000];
            int type = 0;
            rb.Read(buffer, 0, 1);
            zw.SetDictonarySize(System.Convert.ToInt32(buffer[0]));
            while ((type = rb.Read(buffer, 0, 1)) > 0)
            {
                type = buffer[0];
                //File
                if (type == 0)
                {
                    //Read name len
                    rb.Read(buffer, 0, 2);
                    int name_len = System.Convert.ToInt32(buffer[0] * 256 + buffer[1]);

                    string the_name = "";
                    for (int i = 0; i < name_len; i++)
                    {
                        rb.Read(buffer, 0, 1);
                        the_name += System.Convert.ToChar(buffer[0]).ToString();
                    }

                    the_name = the_name.Replace("/", "\\");
                    the_name = dest + "\\" + the_name;

                    //Read file size
                    rb.Read(buffer, 0, 5);
                    long size = (buffer[0]*256*256*256*256)+(buffer[1]*256*256*256)+(buffer[2]*256*256)+(buffer[3]*256)+(buffer[4]);


                    //Write the file
                    FileStream fs = File.Create(the_name);
                    BinaryWriter bw = new BinaryWriter(fs);
                    
                    for (long i = 0 ; i < size; )
                    {
                        long toread = 0;
                        if (i + 2048 > size)
                            toread = size - i;
                        else
                            toread = 2048;

                        rb.Read(buffer, 0, System.Convert.ToInt32(toread));
                        bw.Write(buffer, 0, System.Convert.ToInt32(toread));
                        i += toread;
                    }
                    fs.Close();
                    bw.Close();

                }


                //Compressed file
                if (type == 2)
                {
                    byte[] the_buffer = new byte[10000];
                    //Read name len
                    rb.Read(buffer, 0, 2);
                    int name_len = System.Convert.ToInt32(buffer[0] * 256 + buffer[1]);

                    string the_name = "";
                    for (int i = 0; i < name_len; i++)
                    {
                        rb.Read(buffer, 0, 1);
                        the_name += System.Convert.ToChar(buffer[0]).ToString();
                    }

                    the_name = the_name.Replace("/", "\\");
                    the_name = dest + "\\" + the_name;

                    //Read file size
                    rb.Read(buffer, 0, 5);
                    long size = (buffer[0] * 256 * 256 * 256 * 256) + (buffer[1] * 256 * 256 * 256) + (buffer[2] * 256 * 256) + (buffer[3] * 256) + (buffer[4]);
                    long decompressed_size = 0;

                    byte [] the_name_bytes = Encoding.ASCII.GetBytes(the_name);;
                    int flag = 0;
                    int recv = 0;
                    for (long i = 0; i < size; )
                    {
                        int toread = 0;
                        if (i + 10000 > size)
                            toread = System.Convert.ToInt32(size - i);
                        else
                            toread = 10000;
                        rb.Read(buffer, 0, System.Convert.ToInt32(toread));
                        i += toread;
                        recv = zw.Deompress_buffer_to_file(buffer, toread, the_name_bytes, flag);
                        decompressed_size+= recv;
                        flag = 2;
                    }
                    flag = 3;
                    recv = zw.Deompress_buffer_to_file(buffer, 0, the_name_bytes, flag);
                }

                //Directory
                if (type == 1)
                {
                //Read name len
                rb.Read(buffer, 0, 2);
                int name_len = System.Convert.ToInt32(buffer[0]*256+buffer[1]);

                string the_name = "";
                for (int i = 0; i < name_len; i++)
                {
                        rb.Read(buffer, 0, 1);
                        the_name += System.Convert.ToChar(buffer[0]).ToString();
                }

                the_name = the_name.Replace("/", "\\");
                the_name = dest + "\\" + the_name;
                DirectoryInfo dir = new DirectoryInfo(the_name);
                if (!dir.Exists)
                {
                    
                    dir.Create();
                    dir.Attributes = FileAttributes.Normal;
                }
                }
            }
            readStream.Close();
            rb.Close();
        }


    }
}
