﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using Microsoft.Win32.SafeHandles;
using System.Runtime.InteropServices;
using System.IO;
using System.Management;

namespace ulzwdll
{
    class ulzw
    {
        [DllImport("ulzw_dll.dll")]
        public static extern int dll_set_dictionary_size(int size);

        [DllImport("ulzw_dll.dll")]
        public static extern int dll_compress_chr(byte inp, byte[] outp, int flag);

        [DllImport("ulzw_dll.dll")]
        public static extern int dll_decompress_chr(byte inp, byte[] outp, int flag);

        [DllImport("ulzw_dll.dll")]
        public static extern int dll_compress_buffer_to_file(byte[] input, int len, byte[] save_file, int flag, int append);

        [DllImport("ulzw_dll.dll")]
        public static extern int dll_decompress_buffer_to_file(byte[] input, int len, byte[] save_file, int flag);

        public int Compress_chr(byte input, byte[] outp, int flg)
        {
            return dll_compress_chr(input, outp, flg);
        }

        public int Deompress_chr(byte input, byte[] output, int flg)
        {
            return dll_decompress_chr(input, output, flg);
        }

        public int Compress_buffer_to_file(byte[] input, int len, byte[] save_file, int flag, int append)
        {
            return dll_compress_buffer_to_file(input, len, save_file, flag, append);
        }

        public int Deompress_buffer_to_file(byte[] input, int len, byte[] save_file, int flag)
        {
            return dll_decompress_buffer_to_file(input, len, save_file, flag);
        }

        public int SetDictonarySize(int size)
        {
            return dll_set_dictionary_size(size);
        }

    }
}
